<template>
  <current-household></current-household>

    <h2>{{ $t('household_members_editor.positioning.persons_to_positionnate')}}</h2>

    <div class="list-household-members flex-table">
      <div
          v-for="conc in concerned"
          class="item-bloc"
          v-bind:key="conc.person.id"
      >
          <div class="pick-position item-row">
            <div class="person">
              <!-- <h3>{{ conc.person.text }}</h3> -->
              <h3><person-text :person="conc.person"></person-text></h3>
            </div>
            <div class="holder">
              <button
                class="btn"
                :disabled="!allowHolderForConcerned(conc)"
                :class="{'btn-outline-chill-green': !conc.holder, 'btn-chill-green': conc.holder }"
                @click="toggleHolder(conc)"
              >
                {{ $t('household_members_editor.positioning.holder') }}
              </button>
            </div>
            <div
                v-for="(position, i) in positions"
                :key="`position-${i}`"
                class="position"
            >
              <button
                  class="btn"
                  :class="{ 'btn-primary': conc.position === position, 'btn-outline-primary': conc.position !== position }"
                  @click="moveToPosition(conc.person.id, position.id)"
              >
                {{ position.label.fr }}
              </button>
            </div>
          </div>
          <div class="item-row">
            <div>
              <h6>{{ $t('household_members_editor.positioning.comment') }}</h6>
              <person-comment :conc="conc"></person-comment>
            </div>
          </div>
      </div>
    </div>
</template>

<script>
import MemberDetails from './MemberDetails.vue';
import {mapGetters, mapState} from "vuex";
import CurrentHousehold from "./CurrentHousehold";
import PersonRenderBox from 'ChillPersonAssets/vuejs/_components/Entity/PersonRenderBox.vue';
import PersonComment from './PersonComment';
import PersonText from '../../_components/Entity/PersonText.vue';

export default {
  name: "Positioning",
  components: {
    CurrentHousehold,
    PersonRenderBox,
    PersonComment,
    PersonText
  },
  computed: {
    ...mapState([
        'concerned'
    ]),
    ...mapGetters([
      'persons',
      'concUnpositionned',
      'positions',
      'concByPosition',
    ]),
    allPersonsPositionnated () {
      return this.$store.getters.persons.length > 0
          && this.$store.getters.concUnpositionned.length === 0;
    },
    allowHolderForConcerned: (app) => (conc) => {
      console.log('allow holder for concerned', conc);
      if (conc.position === null) {
        return false;
      }

      return conc.position.allowHolder;
    }
  },
  methods: {
    moveToPosition(person_id, position_id) {
      this.$store.dispatch('markPosition', { person_id, position_id });
    },
    toggleHolder(conc) {
      console.log('toggle holder', conc);
      this.$store.dispatch('toggleHolder', conc);
    }
  },
}
</script>

<style lang="scss" scoped>

.pick-position {
  margin: 0;
  padding: 0;
  display: flex;
  justify-content: flex-end;
  align-items: center;

  .person {
    margin-right: auto;
  }
  .holder {
    margin-right: 1.2rem;
  }
}
</style>
